
%global meadversion 13.0.1
%global namedversion 13.0.1-redhat-1
%global meadalpha .redhat_1
%global meadrel .1
%global serial 3

%bcond_without mead

%define maven_version 13.0.1-redhat-1

Name:           guava-libraries
Version:        %{meadversion}
Release:        %{serial}%{meadalpha}%{meadrel}%{?dist}
Epoch:          0
Summary:        Google Core Libraries for Java
Group:          Development/Java

%if %with mead
Source100: com.google.guava-guava-parent-13.0.1-redhat-1-sources.zip
Source101: com.google.guava-guava-parent-13.0.1-redhat-1-patches.zip
Source102: guava-gwt-13.0.1-redhat-1.jar
Source103: guava-gwt-13.0.1-redhat-1-sources.jar
Source104: guava-gwt-13.0.1-redhat-1.pom
Source105: guava-gwt-13.0.1-redhat-1-javadoc.jar
Source106: guava-parent-13.0.1-redhat-1.pom
Source107: guava-13.0.1-redhat-1-sources.jar
Source108: guava-13.0.1-redhat-1.pom
Source109: guava-13.0.1-redhat-1.jar
Source110: guava-13.0.1-redhat-1-javadoc.jar
%endif

License:        ASL 2.0
URL:            http://code.google.com/p/guava-libraries
%if 0%{?rhel} < 7
Obsoletes:      guava <= 0:13.0.1-1.redhat_1%{?dist}.1
Provides:       guava = %{epoch}:%{version}-%{release}
%endif
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Guava is a suite of core and expanded libraries that include 
utility classes, Google's collections, io classes, and much 
much more.

This project is a complete packaging of all the Guava libraries
into a single jar.  Individual portions of Guava can be used
by downloading the appropriate module and its dependencies.

%package -n guava
Group:          Development/Java

Summary:        Guava: Google Core Libraries for Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       guava-parent = %{epoch}:%{version}-%{release}
%if 0
FIXME: what package provides this in jboss?
XXX: this has optional=true in pom
Requires:       jsr-305
%endif

%description -n guava
Guava is a suite of core and expanded libraries that include
utility classes, google's collections, io classes, and much
much more.

This project is a complete packaging of all the Guava libraries
into a single jar.  Individual portions of Guava can be used
by downloading the appropriate module and its dependencies.

Guava (complete) has only one code dependency - javax.annotation,
per the JSR-305 spec.

%package -n guava-bootstrap
Group:          Development/Java

Summary:        Guava Compilation Bootstrap Classes
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description -n guava-bootstrap
ExecutorService's type parameters changed between JDK5 and JDK6 in a
way that makes it impossible for our invokeAll/invokeAny methods to
match both at compile time. This project builds a JDK6-like copy of
ExecutorService (but with JDK5 compiler settings to ensure that it will
work with JRE5 at runtime).  This project's is then used in the bootstrap
class path of Guava proper.

%package -n guava-gwt
Group:          Development/Java

Summary:        Guava GWT compatible libs
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       guava-parent = %{epoch}:%{version}-%{release}
Requires:       guava = %{epoch}:%{version}-%{release}

%description -n guava-gwt
Guava is a suite of core and expanded libraries that include
utility classes, google's collections, io classes, and much
much more.

This project includes GWT-friendly sources.

%package -n guava-parent
Group:          Development/Java

Summary:        Guava Maven Parent
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       oss-parent

%description -n guava-parent
Guava Maven Parent.

%package -n guava-testlib
Group:          Development/Java

Summary:        Guava Testing Library
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       guava-parent = %{epoch}:%{version}-%{release}
Requires:       guava = %{epoch}:%{version}-%{release}
Requires:       junit >= 0:4.5
Requires:       gwt-devel

%description -n guava-testlib
Guava testlib is a set of java classes used for more convenient
unit testing - particularly to assist the tests for Guava itself.

%if %without mead
%package -n guava-tests
Group:          Development/Java

Summary:        Guava Unit Tests
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       guava-parent = %{epoch}:%{version}-%{release}
BuildRequires:  junit-truth
BuildRequires:  junit >= 0:4.5
BuildRequires:  easymock2
BuildRequires:  maven2-plugin-compiler

%description -n guava-tests
The unit tests for the Guava libraries - separated into a
separate artifact to allow for the testlibs to depend on guava
itself.
%endif

%package javadoc
Group:          Documentation

Summary:        Javadoc for %{name}
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n guava-libraries -T -b 100

%build

%install
%{__rm} -rf %{buildroot}

# jars                                                                                                                                                                                                                                       
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p %{_sourcedir}/guava-gwt-%{namedversion}.jar %{buildroot}%{_javadir}/guava-gwt-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/guava-gwt-%{namedversion}-sources.jar %{buildroot}%{_javadir}/guava-gwt-%{namedversion}-sources.jar
%{__cp} -p %{_sourcedir}/guava-%{namedversion}-sources.jar %{buildroot}%{_javadir}/guava-%{namedversion}-sources.jar
%{__cp} -p %{_sourcedir}/guava-%{namedversion}.jar %{buildroot}%{_javadir}/guava-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%{__cp} -p %{_sourcedir}/guava-gwt-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/guava-gwt-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/guava-gwt-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}/guava-gwt-%{namedversion}-sources.jar
%{__cp} -p %{_sourcedir}/guava-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}/guava-%{namedversion}-sources.jar
%{__cp} -p %{_sourcedir}/guava-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/guava-%{namedversion}.jar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p %{_sourcedir}/guava-gwt-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-guava-gwt.pom
%{__cp} -p %{_sourcedir}/guava-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-guava.pom
%{__cp} -p %{_sourcedir}/guava-parent-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-guava-parent.pom

# depmaps
%add_to_maven_depmap com.google.guava guava-parent %{namedversion} JPP guava-parent
[ %{name} = "guava-parent" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/guava-parent
%add_to_maven_depmap com.google.guava guava %{namedversion} JPP guava
[ %{name} = "guava" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/guava
%add_to_maven_depmap com.google.guava guava-gwt %{namedversion} JPP guava-gwt
[ %{name} = "guava-gwt" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/guava-gwt

# javadoc
# FIXME
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__unzip} -qq %{_sourcedir}/guava-gwt-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/guava-gwt
%{__unzip} -qq %{_sourcedir}/guava-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/guava
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/guava-gwt/META-INF
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/guava/META-INF
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%post -n guava
%update_maven_depmap

%postun -n guava
%update_maven_depmap

%post -n guava-gwt
%update_maven_depmap

%postun -n guava-gwt
%update_maven_depmap

%post -n guava-parent
%update_maven_depmap

%postun -n guava-parent
%update_maven_depmap

%clean
%{__rm} -rf %{buildroot}

%files -n guava-libraries
%defattr(0644,root,root,0755)
%doc AUTHORS CONTRIBUTORS COPYING README README.maven
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/guava-%{namedversion}-sources.jar
%{_javadir}/%{name}/guava-sources.jar
%{_javadir}/%{name}/guava-%{namedversion}.jar
%{_javadir}/%{name}/guava.jar
%{_javadir}/%{name}/guava-gwt-%{namedversion}-sources.jar
%{_javadir}/%{name}/guava-gwt-sources.jar
%{_javadir}/%{name}/guava-gwt-%{namedversion}.jar
%{_javadir}/%{name}/guava-gwt.jar

%files -n guava
%defattr(0644,root,root,0755)
%doc AUTHORS CONTRIBUTORS COPYING README README.maven
%{_javadir}/guava-%{namedversion}-sources.jar
%{_javadir}/guava-sources.jar
%{_javadir}/guava-%{namedversion}.jar
%{_javadir}/guava.jar
%{_mavenpomdir}/JPP-guava.pom
%{_mavendepmapfragdir}/guava

%files -n guava-gwt
%defattr(0644,root,root,0755)
%{_javadir}/guava-gwt-%{namedversion}.jar
%{_javadir}/guava-gwt.jar
%{_javadir}/guava-gwt-%{namedversion}-sources.jar
%{_javadir}/guava-gwt-sources.jar
%{_mavenpomdir}/JPP-guava-gwt.pom
%{_mavendepmapfragdir}/guava-gwt

%files -n guava-parent
%defattr(0644,root,root,0755)
%{_mavenpomdir}/JPP-guava-parent.pom
%{_mavendepmapfragdir}/guava-parent

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%changelog
* Wed May 28 2014 David Walluck <dwalluck@redhat.com> - 13.0.1-3.redhat_1.1
- add Obsoletes/Provides for old guava package (Resolves: bz#1101547)


* Mon May 19 2014 David Walluck <dwalluck@redhat.com> - 13.0.1-2.redhat_1.1
- add files to main package

* Thu Feb 28 2013 Vladimir Dosoudil <dosoudil@redhat.com> - 0:13.0.1-1.redhat_1.1
- Upgrade to 13.0.1

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:11.0.2-0.5.redhat_2.6
- Rebuild for MD5

* Tue Sep 04 2012 Paul Gier <pgier@redhat.com> - 0:11.0.2-0.4.redhat_2.6
- Minor pom patch update 

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:11.0.2-0.4.redhat_2.5
- Rebuild unsigned

* Mon Aug 13 2012 Fernando Nasser <fnasser@redhat.com> - 0:11.0.2-0.4.redhat_2.4
- Rebuild unsigned

* Fri Aug 10 2012 Fernando Nasser <fnasser@redhat.com> - 0:11.0.2-0.4.redhat_2.3
- Rebuild unsigned

* Tue Jul 24 2012 Hui Wang <huwang@redhat.com> - 0:11.0.2-0.4.redhat_1.2
- Add AUTHORS CONTRIBUTORS COPYING README README.maven to %%doc

* Fri Jul 20 2012 Fernando Nasser <fnasser@redhat.com> - 0:11.0.2-0.4.redhat_1.1
- Rebuild using cache signing

* Fri Jul 13 2012 Hui Wang <huwang@redhat.com> 0:11.0.2-0.4_redhat_1
- First mead build

* Thu Jun 14 2012 David Walluck <dwalluck@redhat.com> 0:11.0.2-0.3
- better deploy workaround
- fix macro in comment

* Fri May 25 2012 Martha Benitez <mbenitez@redhat.com> - 0:11.0.2-0.2.redhat_1
- Remove javadoc.jar files from main packages

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:11.0.2-0.1_redhat_1.1
- Rebuild using cache signing

* Mon Mar 26 2012 David Walluck <dwalluck@redhat.com> 0:11.0.2-0.1
- 11.0.2

* Thu Feb 02 2012 David Walluck <dwalluck@redhat.com> 0:10.0.1-0.6
- remove Requires: guava-parent (no pom at runtime)
- remove Requires: jsr-305 (optional)

* Thu Nov 17 2011 David Walluck <dwalluck@redhat.com> 0:10.0.1-0.4_redhat_1
- fix oss-parent version
- fix Release tag

* Tue Nov 15 2011 David Walluck <dwalluck@redhat.com> 0:10.0.1-0.3_redhat_1
- use external libtruth

* Sun Nov 13 2011 David Walluck <dwalluck@redhat.com> 0:10.0.1-0.2_redhat_1
- BuildRequires: jdiff
- fix package names

* Sun Nov 13 2011 David Walluck <dwalluck@redhat.com> 0:10.0.1-0.1_redhat_1
- release
